package com.css.simulation.resource.scheduler.mapper;

import com.css.simulation.resource.scheduler.pojo.po.TaskPO;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.type.JdbcType;

import java.util.List;

@Mapper
public interface TaskMapper {

    @Results(id = "task", value = {
            @Result(column = "id", property = "id", jdbcType = JdbcType.VARCHAR),
            @Result(column = "scene_type", property = "sceneType", jdbcType = JdbcType.VARCHAR),
            @Result(column = "sn_scenario_osc", property = "snScenarioOsc", jdbcType = JdbcType.VARCHAR),
            @Result(column = "sn_scenario_odr", property = "snScenarioOdr", jdbcType = JdbcType.VARCHAR),
            @Result(column = "sn_scenario_osgb", property = "snScenarioOsgb", jdbcType = JdbcType.VARCHAR),
            @Result(column = "scr_scenario_osc", property = "scrScenarioOsc", jdbcType = JdbcType.VARCHAR),
            @Result(column = "scr_scenario_odr", property = "scrScenarioOdr", jdbcType = JdbcType.VARCHAR),
            @Result(column = "scr_scenario_osgb", property = "scrScenarioOsgb", jdbcType = JdbcType.VARCHAR),
            @Result(column = "sa_scenario_osc", property = "saScenarioOsc", jdbcType = JdbcType.VARCHAR),
            @Result(column = "sa_scenario_odr", property = "saScenarioOdr", jdbcType = JdbcType.VARCHAR),
            @Result(column = "sa_scenario_osgb", property = "saScenarioOsgb", jdbcType = JdbcType.VARCHAR),
            @Result(column = "vehicle_id", property = "vehicleId", jdbcType = JdbcType.VARCHAR),
            @Result(column = "max_speed", property = "maxSpeed", jdbcType = JdbcType.DECIMAL),
            @Result(column = "engine_power", property = "enginePower", jdbcType = JdbcType.DECIMAL),
            @Result(column = "max_deceleration", property = "maxDeceleration", jdbcType = JdbcType.DECIMAL),
            @Result(column = "max_steering_angle", property = "maxSteeringAngle", jdbcType = JdbcType.DECIMAL),
            @Result(column = "mass", property = "mass", jdbcType = JdbcType.DECIMAL),
            @Result(column = "front_surface_effective", property = "frontSurfaceEffective", jdbcType = JdbcType.DECIMAL),
            @Result(column = "air_drag_coefficient", property = "airDragCoefficient", jdbcType = JdbcType.DECIMAL),
            @Result(column = "rolling_resistance_coefficient", property = "rollingResistanceCoefficient", jdbcType = JdbcType.DECIMAL),
            @Result(column = "wheel_diameter", property = "wheelDiameter", jdbcType = JdbcType.DECIMAL),
            @Result(column = "wheel_drive", property = "wheelDrive", jdbcType = JdbcType.VARCHAR),
            @Result(column = "overall_efficiency", property = "overallEfficiency", jdbcType = JdbcType.DECIMAL),
            @Result(column = "front_distance", property = "frontDistance", jdbcType = JdbcType.DECIMAL),
            @Result(column = "rear_distance", property = "rearDistance", jdbcType = JdbcType.DECIMAL),
            @Result(column = "left_distance", property = "leftDistance", jdbcType = JdbcType.DECIMAL),
            @Result(column = "right_distance", property = "rightDistance", jdbcType = JdbcType.DECIMAL),
            @Result(column = "height_distance", property = "heightDistance", jdbcType = JdbcType.DECIMAL),
            @Result(column = "wheelbase", property = "wheelbase", jdbcType = JdbcType.DECIMAL),
    })
    @Select("select smpt.id,\n" +
            "       smpt.scene_type,\n" +
            "       sn.xosc_address sn_scenario_osc,\n" +
            "       sn.xodr_address sn_scenario_odr,\n" +
            "       sn.osgb_address sn_scenario_osgb,\n" +
            "       scr.xml_address scr_scenario_osc,\n" +
            "       scr.xodr_address scr_scenario_odr,\n" +
            "       scr.osgb_address scr_scenario_osgb,\n" +
            "       sa.xml_address sa_scenario_osc,\n" +
            "       sa.xodr_address sa_scenario_odr,\n" +
            "       sa.osgb_address sa_scenario_osgb,\n" +
            "       mv.id vehicle_id,\n" +
            "       mv.model_label,\n" +
            "       mv.max_speed,\n" +
            "       mv.engine_power,\n" +
            "       mv.max_deceleration,\n" +
            "       mv.max_steering_angle,\n" +
            "       mv.mass,\n" +
            "       mv.overall_efficiency,\n" +
            "       mv.front_surface_effective,\n" +
            "       mv.air_drag_coefficient,\n" +
            "       mv.rolling_resistance_coefficient,\n" +
            "       mv.wheel_diameter,\n" +
            "       mv.wheel_drive,\n" +
            "       mv.front_distance,\n" +
            "       mv.rear_distance,\n" +
            "       mv.left_distance,\n" +
            "       mv.right_distance,\n" +
            "       mv.height_distance,\n" +
            "       mv.wheelbase\n" +
            "from simulation_manual_project_task smpt\n" +
            "         left join simulation_manual_project smp on smpt.p_id = smp.id\n" +
            "         left join scene_natural sn on smpt.scene_id = sn.natural_id\n" +
            "         left join scene_standards_regulations scr on smpt.scene_id = scr.regulations_id\n" +
            "         left join scene_accident sa on smpt.scene_id = sa.accident_id\n" +
            "         left join model_vehicle mv on smp.vehicle = mv.id\n" +
            "         left join algorithm a on smp.algorithm = a.id\n" +
            "where smpt.p_id = #{projectId}\n")
    List<TaskPO> selectByProjectId(@Param("projectId") String projectId);
}
